﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;

namespace I52165a
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private DataTable mainTable;
        private DataTable gridListControlTable;
        private void Form1_Load(object sender, EventArgs e)
        {
            mainTable = this.GetParentTable();
            gridListControlTable = this.GetChildTable();

            this.gridDataBoundGrid1.DataSource = this.mainTable;

            GridBoundColumn gbc = this.gridDataBoundGrid1.Binder.InternalColumns["childID"];
            gbc.HeaderText = "Children";
            GridStyleInfo style = gbc.StyleInfo;
            style.CellType = "GridListControl";
            style.DataSource = this.gridListControlTable;
            style.DisplayMember = "Name";
            style.ValueMember = "childID";

            this.gridDataBoundGrid1.AllowResizeToFit = false;
            this.gridDataBoundGrid1.Model.ColWidths.ResizeToFit(GridRangeInfo.Row(0), GridResizeToFitOptions.IncludeHeaders);
            this.gridDataBoundGrid1.Model.ColWidths["childID"] = 100;
            this.gridDataBoundGrid1.CurrentCellShowingDropDown += new Syncfusion.Windows.Forms.Grid.GridCurrentCellShowingDropDownEventHandler(gridDataBoundGrid1_CurrentCellShowingDropDown);
        }

        void gridDataBoundGrid1_CurrentCellShowingDropDown(object sender, Syncfusion.Windows.Forms.Grid.GridCurrentCellShowingDropDownEventArgs e)
        {
            GridCurrentCell cc = this.gridDataBoundGrid1.CurrentCell;
            if (cc.Renderer is GridDropDownGridListControlCellRenderer)
            {
                string parentID = this.gridDataBoundGrid1[cc.RowIndex, 1].Text;
                string filter = string.Format("[ParentID] = '{0}'", parentID);
                DataView dv = new DataView(this.gridListControlTable, filter, "ParentID", DataViewRowState.CurrentRows);

                GridListControl list = ((GridDropDownGridListControlCellRenderer)cc.Renderer).ListControlPart;
                list.DataSource = dv;

                list.Grid.HScrollBehavior = GridScrollbarMode.Disabled;
                list.Grid.TableStyle.BackColor = Color.LightGoldenrodYellow;
            }
        }

        private DataTable GetParentTable()
        {
            DataTable dt = new DataTable("ParentTable");

            int nRows = 5;

            dt.Columns.Add(new DataColumn("parentID")); //lower case p
            dt.Columns.Add(new DataColumn("ParentName"));
            dt.Columns.Add(new DataColumn("childID"));

            for (int i = 0; i < nRows; ++i)
            {
                DataRow dr = dt.NewRow();
                dr[0] = i.ToString();
                dr[1] = string.Format("parentName{0}", i);
                dr[2] = i.ToString();
                dt.Rows.Add(dr);
            }

            return dt;
        }

        private DataTable GetChildTable()
        {
            DataTable dt = new DataTable("ChildTable");

            dt.Columns.Add(new DataColumn("childID")); //lower case c
            dt.Columns.Add(new DataColumn("Name"));
            dt.Columns.Add(new DataColumn("ParentID")); //upper case P

            for (int i = 0; i < 20; ++i)
            {
                DataRow dr = dt.NewRow();
                dr[0] = i.ToString();
                dr[1] = string.Format("ChildName{0}", i);
                dr[2] = (i % 5).ToString();
                dt.Rows.Add(dr);
            }
            return dt;
        }
    }
}
